warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/AuthorController.java
package co.edu.usta.warehouse.controllers;

public class AuthorController {
}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/BookController.java
package co.edu.usta.warehouse.controllers;

import co.edu.usta.warehouse.models.Book;
import co.edu.usta.warehouse.services.LibraryService;
import co.edu.usta.warehouse.utilities.Properties;
import lombok.Data;
import org.primefaces.PrimeFaces;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Named;
import java.io.Serializable;
import java.util.List;

@Named("beanBook")
@SessionScoped
@Data
public class BookController implements Serializable {

    @EJB
    LibraryService<Book> bookService;

    private List<Book> books;

    private Book selectedBook;

    private List<Book> selectedBooks;

    @PostConstruct
    public void init() {
        books = bookService.findAll(Book.class);
    }

    public void initObject() {
        this.selectedBook = new Book();
    }

    public void saveBook() {
        if (this.selectedBook.getId() == null) {
            this.books.add(this.selectedBook);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(
                    getMessage("bookSuccessMessage"),
                    getMessage("bookAddedMessage")));
        } else {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(
                    getMessage("bookSuccessMessage"),
                    getMessage("bookUpdatedMessage")));
        }

        PrimeFaces.current().executeScript("PF('manageBookDialog').hide()");
        PrimeFaces.current().ajax().update("form:messages", "form:dt-books");
    }

    public void deleteBook() {
        this.books.remove(this.selectedBook);
        this.selectedBook = null;
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(
                getMessage("bookSuccessMessage"),
                getMessage("bookDeletedMessage")));
        PrimeFaces.current().ajax().update("form:messages", "form:dt-books");
    }

    public String getDeleteButtonMessage() {
        if (hasSelectedBooks()) {
            int size = this.selectedBooks.size();
            return size > 1 ? size + " " + getMessage("bookDeleteMultipleItemsLabel") :
                    getMessage("bookDeleteOneItemLabel");
        }

        return getMessage("bookDeleteLabel");
    }

    public boolean hasSelectedBooks() {
        return this.selectedBooks != null && !this.selectedBooks.isEmpty();
    }

    public void deleteSelectedBooks() {
        this.books.removeAll(this.selectedBooks);
        this.selectedBooks = null;
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(getMessage("bookSuccessMessage"),
                getMessage("booksDeletedMessage")));
        PrimeFaces.current().ajax().update("form:messages", "form:dt-books");
        PrimeFaces.current().executeScript("PF('dtProducts').clearFilters()");
    }

    private String getMessage(String key) {
        return Properties.getBundle("labels.messages", key);
    }

}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/BookTypeController.java
package co.edu.usta.warehouse.controllers;

public class BookTypeController {
}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/CopyController.java
package co.edu.usta.warehouse.controllers;

public class CopyController {
}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/ExampleController.java
package co.edu.usta.warehouse.controllers;

import co.edu.usta.warehouse.models.ModelExample;
import co.edu.usta.warehouse.services.ServiceExample;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

@Named("beanExample")
@SessionScoped
public class ExampleController implements Serializable {

    private static final long serialVersionUID = 1L;

    @EJB
    private ServiceExample serviceExample;

    private List<ModelExample> exampleList;

    public ExampleController() {
        super();
    }

    @PostConstruct
    public void init() {
        listExamples();
    }

    private void listExamples() {
        this.exampleList = serviceExample.findAll();
    }

    public String greeting() {
        return this.serviceExample.greeting();
    }

    public List<ModelExample> getExampleList() {
        return exampleList;
    }

}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/LoanController.java
package co.edu.usta.warehouse.controllers;

public class LoanController {
}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/RoleController.java
package co.edu.usta.warehouse.controllers;

public class RoleController {
}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/RuleController.java
package co.edu.usta.warehouse.controllers;

public class RuleController {
}

warehouse-web/src/main/java/co/edu/usta/warehouse/controllers/UserController.java
package co.edu.usta.warehouse.controllers;

public class UserController {
}

warehouse-web/src/main/webapp/app/book/admin-books.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                template="/templates/admin-template.xhtml">

    <ui:define name="pageTitle">#{msg.bookPageTitle}</ui:define>

    <ui:define name="content">

        <div class="surface-section p-5">
            <div class="card crud-demo">
                <p:toolbar>
                    <p:toolbarGroup>
                        <p:commandButton value="#{msg.bookNewLabel}" icon="pi pi-plus" actionListener="#{beanBook.initObject}"
                                         update=":form:manage-book-content"
                                         oncomplete="PF('manageBookDialog').show()"
                                         styleClass="ui-button-success" style="margin-right: .5rem">
                            <p:resetInput target=":form:manage-book-content"/>
                        </p:commandButton>
                        <p:commandButton id="delete-books-button" value="#{beanBook.deleteButtonMessage}"
                                         icon="pi pi-trash" actionListener="#{beanBook.deleteSelectedBooks}"
                                         styleClass="ui-button-danger" disabled="#{!beanBook.hasSelectedBooks()}"
                                         update="@this">
                            <p:confirm header="#{msg.bookDialogDeleteTitle}" message="#{msg.bookDialogDeleteContent}"
                                       icon="pi pi-exclamation-triangle"/>
                        </p:commandButton>
                    </p:toolbarGroup>
                </p:toolbar>

                <p:dataTable id="dt-books" widgetVar="dtBooks" var="book" value="#{beanBook.books}"
                             reflow="true" styleClass="products-table"
                             selection="#{beanBook.selectedBooks}" rowKey="#{book.id}" paginator="true"
                             rows="10" rowSelectMode="add" paginatorPosition="bottom">
                    <f:facet name="header">
                        <div class="products-table-header">
                            <span class="mr-4" style="font-weight: bold">#{msg.bookTitleTable}</span>

                            <span class="filter-container ui-input-icon-left">
                                    <i class="pi pi-search"/>
                                    <p:inputText id="globalFilter" onkeyup="PF('dtBooks').filter()"
                                                 placeholder="#{msg.bookSearchPlaceholder}"/>
                                </span>

                        </div>
                    </f:facet>

                    <p:ajax event="rowSelect" update=":form:delete-books-button"/>
                    <p:ajax event="rowUnselect" update=":form:delete-books-button"/>
                    <p:ajax event="rowSelectCheckbox" update=":form:delete-books-button"/>
                    <p:ajax event="rowUnselectCheckbox" update=":form:delete-books-button"/>
                    <p:ajax event="toggleSelect" update=":form:delete-books-button"/>

                    <p:column selectionMode="multiple" exportable="false"/>

                    <p:column headerText="#{msg.bookIsbnText}" sortBy="#{book.isbn}" filterBy="#{book.isbn}">
                        <h:outputText value="#{book.isbn}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookTitleText}" sortBy="#{book.title}" filterBy="#{book.title}">
                        <h:outputText value="#{book.title}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookImageText}" exportable="false">
                        <p:graphicImage name="books/#{book.image}" library="images"
                                        styleClass="product-image"/>
                    </p:column>
                    <p:column headerText="#{msg.bookPublicationDateText}" sortBy="#{book.originalPublication}"
                              filterBy="#{book.originalPublication}">
                        <h:outputText value="#{book.originalPublication}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookAuthorText}" sortBy="#{book.author.names}" filterBy="#{book.author.names}">
                        <h:outputText value="#{book.author.names}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookBookTypeText}" sortBy="#{book.bookType.typeName}"
                              filterBy="#{book.bookType.typeName}">
                        <h:outputText value="#{book.bookType.typeName}"/>
                    </p:column>
                    <p:column exportable="false">
                        <p:commandButton icon="pi pi-pencil" update=":form:manage-book-content"
                                         oncomplete="PF('manageBookDialog').show()"
                                         styleClass="edit-button rounded-button ui-button-success mr-1" process="@this">
                            <f:setPropertyActionListener value="#{book}" target="#{beanBook.selectedBook}"/>
                            <p:resetInput target=":form:manage-book-content"/>
                        </p:commandButton>
                        <p:commandButton class="ui-button-warning rounded-button ml-1" icon="pi pi-trash" process="@this"
                                         oncomplete="PF('deleteBookDialog').show()">
                            <f:setPropertyActionListener value="#{book}" target="#{beanBook.selectedBook}"/>
                        </p:commandButton>
                    </p:column>

                </p:dataTable>

                <p:dialog header="#{msg.bookDialogDetailsHeader}" showEffect="fade" modal="true"
                          widgetVar="manageBookDialog" responsive="true">
                    <p:outputPanel id="manage-book-content" class="ui-fluid">
                        <p:outputLabel rendered="#{not empty beanBook.selectedBook}">
                            <div class="grid formgrid ui-fluid">
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label for="isbn" class="font-medium">#{msg.bookIsbnText}</label>
                                    <p:inputText id="isbn" value="#{beanBook.selectedBook.isbn}" required="true" />
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label for="title" class="font-medium">#{msg.bookTitleText}</label>
                                    <p:inputText id="title" value="#{beanBook.selectedBook.title}" required="true" />
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label class="font-medium">#{msg.bookImageText}</label>
                                    <div class="flex align-items-center">
                                        <p:graphicImage name="avatars/circle/avatar-f-3.png"
                                                        library="images" alt="Image"
                                                        styleClass="mr-4"/>
                                        <p:fileUpload mode="simple" skinSimple="true" label="Upload Image" auto="true"
                                                      process="@this"/>
                                    </div>
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label for="original-date" class="font-medium">#{msg.bookPublicationDateText}</label>
                                    <p:datePicker id="original-date" value="#{beanBook.selectedBook.originalPublication}" />
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label class="font-medium">#{msg.bookAuthorText}</label>
                                    <p:selectOneMenu filter="true" filterMatchMode="startsWith">
                                        <f:selectItem itemLabel="Select a Country" itemValue=""/>
                                        <f:selectItem itemLabel="Australia" itemValue="Australia"/>
                                        <f:selectItem itemLabel="Brazil" itemValue="Brazil"/>
                                        <f:selectItem itemLabel="China" itemValue="China"/>
                                        <f:selectItem itemLabel="Egypt" itemValue="Egypt"/>
                                        <f:selectItem itemLabel="France" itemValue="France"/>
                                        <f:selectItem itemLabel="Germany" itemValue="Germany"/>
                                        <f:selectItem itemLabel="India" itemValue="India"/>
                                        <f:selectItem itemLabel="Japan" itemValue="Japan"/>
                                        <f:selectItem itemLabel="Spain" itemValue="Spain"/>
                                        <f:selectItem itemLabel="United States" itemValue="United States"/>
                                    </p:selectOneMenu>
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label class="font-medium">#{msg.bookAuthorText}</label>
                                    <p:selectOneMenu filter="true" filterMatchMode="startsWith">
                                        <f:selectItem itemLabel="Select a Country" itemValue=""/>
                                        <f:selectItem itemLabel="Australia" itemValue="Australia"/>
                                        <f:selectItem itemLabel="Brazil" itemValue="Brazil"/>
                                        <f:selectItem itemLabel="China" itemValue="China"/>
                                        <f:selectItem itemLabel="Egypt" itemValue="Egypt"/>
                                        <f:selectItem itemLabel="France" itemValue="France"/>
                                        <f:selectItem itemLabel="Germany" itemValue="Germany"/>
                                        <f:selectItem itemLabel="India" itemValue="India"/>
                                        <f:selectItem itemLabel="Japan" itemValue="Japan"/>
                                        <f:selectItem itemLabel="Spain" itemValue="Spain"/>
                                        <f:selectItem itemLabel="United States" itemValue="United States"/>
                                    </p:selectOneMenu>
                                </div>
                            </div>
                        </p:outputLabel>
                        <!-- Code ends here -->

                    </p:outputPanel>

                    <f:facet name="footer">
                        <p:commandButton value="#{msg.bookSaveButtonLabel}" icon="pi pi-check" actionListener="#{beanBook.saveBook}"
                                         update="manage-book-content" process="manage-book-content @this"/>
                        <p:commandButton value="#{msg.bookCancelButtonLabel}" icon="pi pi-times"
                                         onclick="PF('manageBookDialog').hide()"
                                         class="ui-button-secondary"/>
                    </f:facet>
                </p:dialog>

                <p:confirmDialog widgetVar="deleteBookDialog" showEffect="fade" width="300"
                                 message="#{msg.bookDialogDeleteMessage}" header="#{msg.bookDialogDeleteTitle}" severity="warn">
                    <p:commandButton value="#{msg.bookDialogDeleteYesOption}" icon="pi pi-check" actionListener="#{beanBook.deleteBook}"
                                     process="@this" oncomplete="PF('deleteBookDialog').hide()"/>
                    <p:commandButton value="#{msg.bookDialogDeleteNoOption}" type="button" styleClass="ui-button-secondary" icon="pi pi-times"
                                     onclick="PF('deleteBookDialog').hide()"/>
                </p:confirmDialog>

                <p:confirmDialog global="true" showEffect="fade" width="300">
                    <p:commandButton value="#{msg.bookDialogDeleteYesOption}" type="button" styleClass="ui-confirmdialog-yes"
                                     icon="pi pi-check"/>
                    <p:commandButton value="#{msg.bookDialogDeleteNoOption}" type="button" styleClass="ui-confirmdialog-no ui-button-secondary"
                                     icon="pi pi-times"/>
                </p:confirmDialog>
            </div>
        </div>

    </ui:define>

</ui:composition>

warehouse-web/src/main/webapp/templates/error-page/404.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui">

<ui:composition template="/templates/error-template.xhtml">
    <ui:define name="pageTitle">#{msg.page404Title}</ui:define>

    <ui:define name="bodyContent">
        <h:form>
            <p:panel header="#{msg.page404Title}" style="text-align: center;">
                <p:graphicImage alt="#{msg.page404AltImage}" url="/resources/images/404.svg" style="width: 75%" />
                <p:linkButton value="#{msg.page404RedirectButton}" icon="ui-icon-home"
                              styleClass="rounded-button ui-button-info"
                              outcome="/index"/>
            </p:panel>
        </h:form>

    </ui:define>
</ui:composition>
</html>

warehouse-web/src/main/webapp/templates/error-template.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui">

<f:view>
    <h:head>
        <title><ui:insert name="pageTitle"/></title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <meta http-equiv="Expires" content="0"/>
        <meta http-equiv="Pragma" content="no-cache"/>
        <meta http-equiv="Cache-Control"
              content="no-cache, no-store, must-revalidate"/>

        <link rel="stylesheet"
              href="#{request.contextPath}/resources/css/global-style.css"/>
    </h:head>
    <body>
    <div>
        <ui:insert name="bodyContent"/>
    </div>
    </body>
</f:view>
</html>